#
#   Makefile.fpc for Free Pascal Source Tree
#

[package]
name=fpc
version=3.2.2

[target]
dirs=fpcsrc fpcdocs

[require]
nortl=y

[install]
fpcpackage=y

[default]
fpcdir=.
rule=help

[prerules]
# Replace FPC_VERSION by PACKAGE_VERSION in order the install paths be set up
# using the package version instead of the starting compiler version.
# Save the original FPC_VERSION in order to restore it later.
BS_FPC_VERSION:=$(FPC_VERSION)
# Be sure to remove all suffixes like -beta from PACKAGE_VERSION
FPC_VERSION:=$(firstword $(subst -, ,$(PACKAGE_VERSION)))

# Check if install/ subdir is available
ifneq ($(wildcard install),)
CVSINSTALL=install
else
CVSINSTALL=.
endif

# Prefix for units
ifneq ($(findstring $(OS_SOURCE),$(LIMIT83fs)),)
PKGUNITSPRE=u
else
PKGUNITSPRE=units-
endif

# Cross compile needs a prefix to not conflict with original packages
ifdef CROSSINSTALL
PKGPRE=$(FULL_TARGET)-
else
PKGPRE=
endif

# We want to have the resulting .zips in the current dir
ifndef DIST_DESTDIR
export DIST_DESTDIR:=$(BASEDIR)
endif

# This list should be the same as in fpcsrc/Makefile.fpc and in fpcsrc/packages/ide/Makefile.fpc
GDBMI_DEFAULT_OS_LIST=aix darwin freebsd haiku linux netbsd openbsd solaris win32 win64


[rules]
# Restore FPC_VERSION
FPC_VERSION:=$(BS_FPC_VERSION)

#####################################################################
# Main targets
#####################################################################

.PHONY: help checkfpcdir

help:
	@$(ECHO)
	@$(ECHO) Targets
	@$(ECHO)    all         Alias for build
	@$(ECHO)    build       Build a new compiler and all packages
	@$(ECHO)    install     Install newly build files
	@$(ECHO)    zipinstall  Create a zip/tar archive for every package
	@$(ECHO)    singlezipinstall
	@$(ECHO)                Create a single zip/tar archive
	@$(ECHO)    crosszipinstall
	@$(ECHO)                Build a cross compiler and create zip/tar for every package
	@$(ECHO)    crosssinglezipinstall
	@$(ECHO)                Build a cross compiler and a create single zip/tar archive
	@$(ECHO)
	@$(ECHO) Distribution Targets:
	@$(ECHO)    rpm         Build linux .rpm packages
	@$(ECHO)    deb         Build linux .deb packages
	@$(ECHO)    inno        "Build Windows (Innosetup) based installer"
	@$(ECHO)    innox64     "Build Win32-Win64 cross compiler installer"
	@$(ECHO)    innox86x64  "Build Windows (Innosetup) combined installer for Win32 and Win64"
	@$(ECHO)    innoce      "Build Win32-Wince cross compiler installer"
	@$(ECHO)    innomsdos   "Build Win32-MsDos cross compiler installer"
	@$(ECHO)    innoandroid "Build Win32-Android cross compiler installer"
	@$(ECHO)    tar         Build .tar installer
	@$(ECHO)
	@$(ECHO) FV based installer Targets:
	@$(ECHO)    go32v2zip   Build .zip files for go32v2
	@$(ECHO)    os2zip      Build .zip files for OS/2
	@$(ECHO)    sourcezip   Build .zip files for the sources
	@$(ECHO)
	@exit


##########################################################################
# Packaging
##########################################################################

ifdef LINKISCOPY
ifndef LINKTREE
LINKTREE:=$(CPPROG) -Rfp
endif
else
ifndef LINKTREE
LINKTREE:=$(CPPROG) -Rfpl
endif
endif

BUILDSTAMP=fpcsrc/build-stamp.$(FULL_TARGET)

.PHONY: all clean distclean build install installbase zipinstall singlezipinstall crosssinglezipinstall

all: build

build: $(BUILDSTAMP)
$(BUILDSTAMP):
	$(MAKE) -C fpcsrc build

buildx64: fpcsrc/build-stamp.x86_64-win64

fpcsrc/build-stamp.x86_64-win64:
	$(MAKE) -C fpcsrc build OS_TARGET=win64 CPU_TARGET=x86_64

buildce: fpcsrc/build-stamp.arm-wince

fpcsrc/build-stamp.arm-wince:
	$(MAKE) -C fpcsrc build OS_TARGET=wince CPU_TARGET=arm
		
buildjvm: fpcsrc/build-stamp.jvm-java fpcsrc/build-stamp.jvm-android

fpcsrc/build-stamp.jvm-java:
# currently, jvm supports only build base, so we have to use make all here		
	$(MAKE) -C fpcsrc all OS_TARGET=java CPU_TARGET=jvm
		
fpcsrc/build-stamp.jvm-android:
# currently, jvm supports only build base, so we have to use make all here		
	$(MAKE) -C fpcsrc all OS_TARGET=android CPU_TARGET=jvm

fpcsrc/build-stamp.cross-msdos:
	$(MAKE) -C fpcsrc clean buildbase OS_TARGET=msdos CPU_TARGET=i8086 OPT="-CX -XXs" BINUTILSPREFIX= CROSSOPT="-Wm$(MEMORY_MODEL) -Cp$(SUBARCH)"
	$(ECHO) $(DATE) > fpcsrc/build-stamp.cross-msdos

clean: $(addsuffix _distclean,$(TARGET_DIRS))
	-rm -f fpcsrc/build-stamp.*

distclean: clean

installbase:
# create dirs
	$(MKDIR) $(INSTALL_BASEDIR)
	$(MKDIR) $(INSTALL_BINDIR)
ifeq ($(OS_TARGET),wince)
	$(COPY) $(addprefix $(CVSINSTALL)/crossbinwce/, *.exe) $(INSTALL_BINDIR)
endif
ifeq ($(OS_TARGET),win64)
	$(COPY) $(addprefix $(CVSINSTALL)/crossbinw64/, *.exe) $(INSTALL_BINDIR)
	-$(COPY) $(CVSINSTALL)/binw32/gcc.exe $(INSTALL_BINDIR)/x86_64-win64-gcc.exe
endif
ifeq ($(OS_TARGET),msdos)
	$(COPY) $(addprefix $(CVSINSTALL)/crossbinmsdos/, *.exe) $(INSTALL_BINDIR)
endif
# readme, whatsnew, licenses and additional docs, they must be always included
	$(MKDIR) $(INSTALL_DOCDIR)
	-$(COPY) $(addprefix $(CVSINSTALL)/doc/,*.txt copying* license* faq.*) $(INSTALL_DOCDIR)
# but don't include readme-jvm.txt for lfn challenged targets (gives problems unzipping)
ifneq ($(findstring $(OS_TARGET),$(LIMIT83fs)),)
	$(DEL) $(INSTALL_DOCDIR)/readme-jvm.txt
endif
ifndef SNAPSHOT
ifndef CROSSINSTALL
# bingo32 (cwsdpmi,wmemu387.dxe)
ifeq ($(OS_TARGET),go32v2)
	$(COPY) $(CVSINSTALL)/bingo32/*.dxe $(INSTALL_BINDIR)
	$(COPY) $(CVSINSTALL)/bingo32/*.exe $(INSTALL_BINDIR)
endif
# binw32 (*.dll,*.exe,*.ico)
ifneq ($(patsubst %/,%,$(subst \,/,$(dir $(CPPROG)))),$(patsubst %/,%,$(subst \,/,$(INSTALL_BINDIR))))
ifeq ($(OS_TARGET),win32)
	$(COPY) $(addprefix $(CVSINSTALL)/binw32/,*.ico *.exe *.dll *.h *.manifest) $(INSTALL_BINDIR)
endif
# binw64 (some extensions have no corresponding files yet, thus we need to
# ignore errors.
ifeq ($(OS_TARGET),win64)
	-$(COPY) $(addprefix $(CVSINSTALL)/binw64/,*.ico *.exe *.dll *.h *.manifest) $(INSTALL_BINDIR)
	-$(COPY) $(CVSINSTALL)/binw32/gcc.exe $(INSTALL_BINDIR)/x86_64-win64-gcc.exe
endif
endif
# binos2 (emx.dll,emxwrap.dll,unzip32.dll,fp2.ico)
ifeq ($(OS_TARGET),os2)
	$(COPY) $(addprefix $(CVSINSTALL)/binos2/,*.ico *.dll) $(INSTALL_BINDIR)
endif
# binos2 (emx.dll,emxwrap.dll,unzip32.dll,fp2.ico)
ifeq ($(OS_TARGET),emx)
	$(COPY) $(addprefix $(CVSINSTALL)/binos2/,*.ico *.dll) $(INSTALL_BINDIR)
endif
# manpages for UNIX systems
ifneq ($(findstring $(OS_TARGET),linux freebsd netbsd openbsd sunos qnx),)
	$(MAKE) -C $(CVSINSTALL)/man installman
endif
# jvm utils
ifeq ($(CPU_TARGET),jvm)
	$(COPY) $(CVSINSTALL)/jvm/*.jar $(INSTALL_BINDIR)
endif
endif
endif
# install generated things, explicitly pass INSTALL_BASEDIR
	$(MAKE) -C fpcsrc installbase INSTALL_BASEDIR=$(INSTALL_BASEDIR)

install: $(BUILDSTAMP)
	$(MAKE) installbase
	$(MAKE) -C fpcsrc installother

crossinstall: 
	$(MAKE) $(BUILDSTAMP) CROSSINSTALL=1
	$(MAKE) installbase CROSSINSTALL=1
	$(MAKE) -C fpcsrc installother CROSSINSTALL=1

zipinstall: $(BUILDSTAMP)
	$(MAKE) fpc_zipinstall ZIPTARGET=installbase ZIPNAME=base
	$(MAKE) -C fpcsrc zipinstallother

singlezipinstall: $(BUILDSTAMP)
ifeq ($(FULL_SOURCE),$(FULL_TARGET))
	$(MAKE) fpc_zipinstall ZIPTARGET=install FULLZIPNAME=fpc-$(PACKAGE_VERSION).$(TARGETSUFFIX)
else
	$(MAKE) fpc_zipinstall ZIPTARGET=install FULLZIPNAME=fpc-$(PACKAGE_VERSION).$(TARGETSUFFIX).built.on.$(SOURCESUFFIX)
endif

crosszipinstall:
	$(MAKE) $(BUILDSTAMP) CROSSINSTALL=1
	$(MAKE) fpc_zipinstall CROSSINSTALL=1 ZIPTARGET=installbase ZIPNAME=base
	$(MAKE) -C fpcsrc zipinstallother CROSSINSTALL=1

crosssinglezipinstall:
	$(MAKE) $(BUILDSTAMP) CROSSINSTALL=1
	$(MAKE) fpc_zipinstall ZIPTARGET=install FULLZIPNAME=fpc-$(PACKAGE_VERSION).$(SOURCESUFFIX).cross.$(TARGETSUFFIX) CROSSINSTALL=1

##########################################################################
# Docs
##########################################################################

.PHONY: docspdf makepackdocs docsrcinstall docsrc

# We don't want the package name fpc in the path
DOCSOURCEDIR=$(INSTALL_SOURCEDIR)/../docs

docspdf:
	$(MAKE) -C fpcdocs pdfinstall DOCINSTALLDIR=$(PACKDIR)

# Used by makepack to generate unix installation .tar
makepackdocs:
	$(MAKE) fpc_zipinstall ZIPTARGET=docspdf FULLZIPNAME=docs

docsrcinstall:
	$(MAKE) -C fpcdocs distclean
	$(MKDIR) $(DOCSOURCEDIR)
	$(COPYTREE) fpcdocs/* $(DOCSOURCEDIR)

docsrc:
	$(MAKE) fpc_zipinstall ZIPTARGET=docsrcinstall FULLZIPNAME=docsrc


##########################################################################
# Demos
##########################################################################

.PHONY: demozip

# We don't want the package name fpc in the path
ifeq ($(MAKEPACK),)
ifdef UNIXHier
DEMOSOURCEDIR=$(INSTALL_DOCDIR)/../demo
else
DEMOSOURCEDIR=$(INSTALL_PREFIX)/demo
endif
else
DEMOSOURCEDIR=$(PACKDIR)
endif

demosrcinstall:
	$(MAKE) -C demo clean
	$(MKDIR) $(DEMOSOURCEDIR)
	$(COPYTREE) demo/* $(DEMOSOURCEDIR)

demozip:
	$(MAKE) fpc_zipinstall ZIPTARGET=demosrcinstall FULLZIPNAME=demo


##########################################################################
# Source targets
##########################################################################

.PHONY: sourcebase sourcezip

# We don't want the fpc/ package prefix
INSTALL_BASESOURCEDIR=$(INSTALL_SOURCEDIR)/..

sourcebase:
# base Makefiles needed for sources
	$(MKDIR) $(INSTALL_BASESOURCEDIR)
	$(MKDIR) $(INSTALL_BASESOURCEDIR)/packages
	$(COPY) fpcsrc/Makefile*  $(INSTALL_BASESOURCEDIR)
	$(COPY) fpcsrc/packages/Makefile* $(INSTALL_BASESOURCEDIR)/packages
	$(COPY) fpcsrc/packages/fpmake.pp $(INSTALL_BASESOURCEDIR)/packages
	$(COPY) fpcsrc/packages/fpmake_add.inc $(INSTALL_BASESOURCEDIR)/packages
	$(COPY) fpcsrc/packages/fpmake_proc.inc $(INSTALL_BASESOURCEDIR)/packages

sourcezip:
	$(MAKE) fpc_zipinstall ZIPTARGET=sourcebase ZIPNAME=base ZIPSUFFIX=$(ZIPSOURCESUFFIX)
	$(MAKE) -C fpcsrc compiler_zipsourceinstall
	$(MAKE) -C fpcsrc rtl_zipsourceinstall
	$(MAKE) -C fpcsrc packages_zipsourceinstall ZIPPREFIX=$(PKGUNITSPRE)
	$(MAKE) -C fpcsrc utils_zipsourceinstall
	$(MAKE) -C fpcsrc installer_zipsourceinstall


##########################################################################
# OS targets
##########################################################################

BUILDTARGETS=go32v2 win32 linux freebsd netbsd openbsd os2 emx sunos qnx beos win64 wince

.PHONY: go32v2 win32 win64 wince linux freebsd os2 emx netbsd openbsd go32v2zip win32zip linuxzip freebsdzip os2zip emxzip netbsdzip openbsdzip

$(BUILDTARGETS): checkfpcdir
	$(MAKE) install OS_TARGET=$@

$(addsuffix zip,$(filter-out beos sunos,$(BUILDTARGETS))): checkfpcdir
	$(MAKE) zipinstall OS_TARGET=$(subst zip,,$@)

beoszip : checkfpcdir
	$(MAKE) zipinstall OS_TARGET=beos USEZIP=1

sunoszip: checkfpcdir
	$(MAKE) zipinstall OS_TARGET=sunos TARPROG=gtar


##########################################################################
# Dos, OS/2 Short 8.3 Names
##########################################################################

.PHONY: renametoshort shortsrc shortbin shortnames

renametoshort:
# Compiler parts
	-$(MOVE) $(PKGPRE)base$(ZIPSUFFIX).zip base$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)compiler$(ZIPSUFFIX).zip comp$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)installer$(ZIPSUFFIX).zip inst$(ZIPSUFFIXSHORT).zip
# Utilities parts
	-$(MOVE) $(PKGPRE)asld$(ZIPSUFFIX).zip asld$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)make$(ZIPSUFFIX).zip make$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)gdb$(ZIPSUFFIX).zip gdb$(ZIPSUFFIXSHORT).zip
# Packages in alphabetical order
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)a52$(ZIPSUFFIX).zip ua52$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)ami-extra$(ZIPSUFFIX).zip uami$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)amunits$(ZIPSUFFIX).zip uamu$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)arosunits$(ZIPSUFFIX).zip uaru$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)aspell$(ZIPSUFFIX).zip uasp$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)bfd$(ZIPSUFFIX).zip ubfd$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)bzip2$(ZIPSUFFIX).zip ubz2$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)cairo$(ZIPSUFFIX).zip ucai$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)cdrom$(ZIPSUFFIX).zip ucdr$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)chm$(ZIPSUFFIX).zip uchm$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)cocoaint$(ZIPSUFFIX).zip ucoc$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)dblib$(ZIPSUFFIX).zip udblb$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)dbus$(ZIPSUFFIX).zip udbus$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)dts$(ZIPSUFFIX).zip udts$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fastcgi$(ZIPSUFFIX).zip ufcgi$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-async$(ZIPSUFFIX).zip ufcla$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-base$(ZIPSUFFIX).zip ufclb$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-db$(ZIPSUFFIX).zip ufcld$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-extra$(ZIPSUFFIX).zip ufcex$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-fpcunit$(ZIPSUFFIX).zip ufclu$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-image$(ZIPSUFFIX).zip ufcli$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-js$(ZIPSUFFIX).zip ufcjs$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-json$(ZIPSUFFIX).zip ufclj$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-net$(ZIPSUFFIX).zip ufcln$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-passrc$(ZIPSUFFIX).zip ufcls$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-pdf$(ZIPSUFFIX).zip ufcpd$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-process$(ZIPSUFFIX).zip ufclp$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-registry$(ZIPSUFFIX).zip ufclr$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-report$(ZIPSUFFIX).zip ufcre$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-res$(ZIPSUFFIX).zip ufcle$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-sdo$(ZIPSUFFIX).zip ufcsd$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-sound$(ZIPSUFFIX).zip ufsnd$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-stl$(ZIPSUFFIX).zip ufcst$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-web$(ZIPSUFFIX).zip ufclw$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fcl-xml$(ZIPSUFFIX).zip ufclx$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fftw$(ZIPSUFFIX).zip ufftw$(ZIPSUFFIXSHORT).zip
# This package corresponds to fpcsrc/packages main directory
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fpc-all$(ZIPSUFFIX).zip ufpca$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fpgtk$(ZIPSUFFIX).zip ufpgt$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fpindexer$(ZIPSUFFIX).zip ufpi$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fpmkunit$(ZIPSUFFIX).zip ufpmk$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fppkg$(ZIPSUFFIX).zip ufppk$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fuse$(ZIPSUFFIX).zip ufuse$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)fv$(ZIPSUFFIX).zip ufv$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)gdbint$(ZIPSUFFIX).zip ugdb$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)gdbm$(ZIPSUFFIX).zip ugdbm$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)ggi$(ZIPSUFFIX).zip uggi$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)gmp$(ZIPSUFFIX).zip ugmp$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)gnome1$(ZIPSUFFIX).zip ugno1$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)gnutls$(ZIPSUFFIX).zip ugtls$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)googleapi$(ZIPSUFFIX).zip ugapi$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)graph$(ZIPSUFFIX).zip ugrph$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)gtk1$(ZIPSUFFIX).zip ugtk1$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)gtk2$(ZIPSUFFIX).zip ugtk2$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)hash$(ZIPSUFFIX).zip uhash$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)hermes$(ZIPSUFFIX).zip uherm$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)httpd13$(ZIPSUFFIX).zip uhd13$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)httpd20$(ZIPSUFFIX).zip uhd20$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)httpd22$(ZIPSUFFIX).zip uhd22$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)httpd24$(ZIPSUFFIX).zip uhd24$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)ibase$(ZIPSUFFIX).zip uibas$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)iconvenc$(ZIPSUFFIX).zip uicve$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)ide$(ZIPSUFFIX).zip uide$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)imagemagick$(ZIPSUFFIX).zip uimgm$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)imlib$(ZIPSUFFIX).zip uimlb$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)iosxlocale$(ZIPSUFFIX).zip uiosl$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)jni$(ZIPSUFFIX).zip ujni$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)ldap$(ZIPSUFFIX).zip uldap$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libc$(ZIPSUFFIX).zip ulibc$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libcups$(ZIPSUFFIX).zip ulcup$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libcurl$(ZIPSUFFIX).zip ulcur$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libenet$(ZIPSUFFIX).zip ulnet$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libffi$(ZIPSUFFIX).zip ulffi$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libfontconfig$(ZIPSUFFIX).zip ulfcg$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libgbafpc$(ZIPSUFFIX).zip ulgba$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libgc$(ZIPSUFFIX).zip ulgc$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libgd$(ZIPSUFFIX).zip ulgd$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libmagic$(ZIPSUFFIX).zip ulmag$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libmicrohttpd$(ZIPSUFFIX).zip ulmic$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libndsfpc$(ZIPSUFFIX).zip ulnds$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libogcfpc$(ZIPSUFFIX).zip ulogc$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libpng$(ZIPSUFFIX).zip ulpng$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libsee$(ZIPSUFFIX).zip ulsee$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libtar$(ZIPSUFFIX).zip ultar$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libusb$(ZIPSUFFIX).zip ulusb$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libvlc$(ZIPSUFFIX).zip ulvlc$(ZIPSUFFIXSHORT).zip
# This package resides in fpcsrc/packages/libxml directory
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)libxml2$(ZIPSUFFIX).zip ulxml$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)lua$(ZIPSUFFIX).zip ulua$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)mad$(ZIPSUFFIX).zip umad$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)matroska$(ZIPSUFFIX).zip umatk$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)modplug$(ZIPSUFFIX).zip umplg$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)morphunits$(ZIPSUFFIX).zip umrph$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)mysql$(ZIPSUFFIX).zip umysq$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)ncurses$(ZIPSUFFIX).zip uncrs$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)newt$(ZIPSUFFIX).zip unewt$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)numlib$(ZIPSUFFIX).zip unlib$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)nvapi$(ZIPSUFFIX).zip unva$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)objcrtl$(ZIPSUFFIX).zip uobjc$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)odata$(ZIPSUFFIX).zip uodat$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)odbc$(ZIPSUFFIX).zip uodbc$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)oggvorbis$(ZIPSUFFIX).zip uoggv$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)openal$(ZIPSUFFIX).zip uoal$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)opencl$(ZIPSUFFIX).zip uocl$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)opengl$(ZIPSUFFIX).zip uogl$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)opengles$(ZIPSUFFIX).zip uogls$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)openssl$(ZIPSUFFIX).zip uossl$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)oracle$(ZIPSUFFIX).zip uora$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)os2units$(ZIPSUFFIX).zip uos2$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)os4units$(ZIPSUFFIX).zip uos4$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)palmunits$(ZIPSUFFIX).zip upalm$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)pasjpeg$(ZIPSUFFIX).zip upjp$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)pastojs$(ZIPSUFFIX).zip up2js$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)paszlib$(ZIPSUFFIX).zip upzl$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)pcap$(ZIPSUFFIX).zip upcap$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)postgres$(ZIPSUFFIX).zip upgr$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)proj4$(ZIPSUFFIX).zip uprj4$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)ptc$(ZIPSUFFIX).zip uptc$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)pthreads$(ZIPSUFFIX).zip upthr$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)pxlib$(ZIPSUFFIX).zip upxl$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)qlunits$(ZIPSUFFIX).zip uqlun$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)regexpr$(ZIPSUFFIX).zip ureg$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)rexx$(ZIPSUFFIX).zip urexx$(ZIPSUFFIXSHORT).zip
# This package resides in fpcsrc/packages/librsvg directory
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)rsvg$(ZIPSUFFIX).zip ursvg$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)rtl-console$(ZIPSUFFIX).zip urtlc$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)rtl-extra$(ZIPSUFFIX).zip urtle$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)rtl-generics$(ZIPSUFFIX).zip urtlg$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)rtl-objpas$(ZIPSUFFIX).zip urtlo$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)rtl-unicode$(ZIPSUFFIX).zip urtlu$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)sdl$(ZIPSUFFIX).zip usdl$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)sndfile$(ZIPSUFFIX).zip usndf$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)sqlite$(ZIPSUFFIX).zip usqlt$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)svgalib$(ZIPSUFFIX).zip usvga$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)symbolic$(ZIPSUFFIX).zip usymb$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)syslog$(ZIPSUFFIX).zip usysl$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)tcl$(ZIPSUFFIX).zip utcl$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)tosunits$(ZIPSUFFIX).zip utos$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)tplylib$(ZIPSUFFIX).zip utpll$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)univint$(ZIPSUFFIX).zip uuniv$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)unixutil$(ZIPSUFFIX).zip uunix$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)unzip$(ZIPSUFFIX).zip uzip$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)users$(ZIPSUFFIX).zip uuser$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)utmp$(ZIPSUFFIX).zip uutmp$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)uuid$(ZIPSUFFIX).zip uuuid$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)vcl-compat$(ZIPSUFFIX).zip uvcl$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)webidl$(ZIPSUFFIX).zip uwidl$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)winceunits$(ZIPSUFFIX).zip uwice$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)winunits-base$(ZIPSUFFIX).zip uwib$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)winunits-jedi$(ZIPSUFFIX).zip uwij$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)x11$(ZIPSUFFIX).zip ux11$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)xforms$(ZIPSUFFIX).zip uxfrm$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)zlib$(ZIPSUFFIX).zip uzlib$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)$(PKGUNITSPRE)zorba$(ZIPSUFFIX).zip uzorb$(ZIPSUFFIXSHORT).zip
# Utils packages in alphabetical order
	-$(MOVE) $(PKGPRE)utils$(ZIPSUFFIX).zip utils$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-debugsrv$(ZIPSUFFIX).zip dbgs$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-dxegen$(ZIPSUFFIX).zip dxeg$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-fpcm$(ZIPSUFFIX).zip fpcm$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-fpcmkcfg$(ZIPSUFFIX).zip fpck$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-fpcres$(ZIPSUFFIX).zip fprs$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-fpcreslipo$(ZIPSUFFIX).zip fprl$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-fpdoc$(ZIPSUFFIX).zip fpdc$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-fpmc$(ZIPSUFFIX).zip fpmc$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-fppkg$(ZIPSUFFIX).zip fpkg$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-fprcp$(ZIPSUFFIX).zip fprc$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-h2pas$(ZIPSUFFIX).zip h2pa$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-ihxutil$(ZIPSUFFIX).zip ihxu$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-importtl$(ZIPSUFFIX).zip impt$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-instantfpc$(ZIPSUFFIX).zip ifpc$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-javaapp$(ZIPSUFFIX).zip jvp$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-json2pas$(ZIPSUFFIX).zip jsnp$(ZIPSUFFIXSHORT).zip
# This package resides in fpcsrc/utils/tply directory
	-$(MOVE) $(PKGPRE)utils-lexyacc$(ZIPSUFFIX).zip lexy$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-mksymbian$(ZIPSUFFIX).zip mksb$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-pas2fpm$(ZIPSUFFIX).zip p2fp$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-pas2jni$(ZIPSUFFIX).zip p2jn$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-pas2js$(ZIPSUFFIX).zip pjs$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-pas2ut$(ZIPSUFFIX).zip p2ut$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-rmwait$(ZIPSUFFIX).zip rmw$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-sim_pasc$(ZIPSUFFIX).zip smp$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-svn2cvs$(ZIPSUFFIX).zip s2c$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-unicode$(ZIPSUFFIX).zip ucd$(ZIPSUFFIXSHORT).zip
	-$(MOVE) $(PKGPRE)utils-wasmbin$(ZIPSUFFIX).zip wsbn$(ZIPSUFFIXSHORT).zip

# Sources only
	-$(MOVE) $(PKGPRE)rtl$(ZIPSUFFIX).zip rtl$(ZIPSUFFIXSHORT).zip

shortsrc:
	$(MAKE) renametoshort ZIPSUFFIX=$(ZIPSOURCESUFFIX) ZIPSUFFIXSHORT=src
	$(MAKE) renametoshort ZIPSUFFIX=-$(FPC_VERSION)$(ZIPSOURCESUFFIX) ZIPSUFFIXSHORT=src

shortbin:
	$(MAKE) renametoshort ZIPSUFFIXSHORT=$(SHORTSUFFIX)
	$(MAKE) renametoshort ZIPSUFFIX=$(SHORTSUFFIX) ZIPSUFFIXSHORT=$(SHORTSUFFIX)
	$(MAKE) renametoshort PKGPRE=$(OS_TARGET)- ZIPSUFFIXSHORT=$(SHORTSUFFIX)

shortnames: shortsrc shortbin

# Build dir
ifndef BUILDDIR
BUILDDIR=$(BASEDIR)/build
endif

# Use of GDBMI for text mode IDE, starting with version 3.1.1
# Use PACKAGE_VERSION here instead of FPC_VERSION
# to avoid checking for GDB if starting compiler is 3.0.4 release
ifeq ($(findstring 3.0.,$(PACKAGE_VERSION)),)
ifndef NOGDB
#  Determine if we should use GDBMI for Text Mode IDE compilation
ifndef NOGDBMI
ifneq ($(findstring $(OS_TARGET),$(GDBMI_DEFAULT_OS_LIST)),)
export GDBMI=1
endif
endif #NOGDB
endif #Not 3.0.X version

ifdef GDBMI
ifeq ($(GDBMI),0)
LOOKFORLIBGDBDIR=1
else
LOOKFORLIBGDBDIR=0
endif #GDBMI=0
else
ifndef NOGDB
LOOKFORLIBGDBDIR=1
else
LOOKFORLIBGDBDIR=0
endif #NOGDB
endif #GDBMI

#
# Automatic detection if libgdb.a is present (logic copied from packages/ide/Makefile.fpc)
#
ifeq ($(LOOKFORLIBGDBDIR),1)
# Try to find GDB library
# Look for a valid LIBGDBDIR environment variable
ifdef LIBGDBDIR
override LIBGDBFILE:=$(firstword $(wildcard $(addsuffix /libgdb.a,$(LIBGDBDIR))))
endif

# Use default dirs if not available
ifeq ($(LIBGDBFILE),)
# Default locations <target>/<cpu> (linux) or <target> (win32,go32v2) only
override GDBLIBDIR=$(wildcard fpcsrc/libgdb/$(OS_TARGET)/$(CPU_TARGET))
override LIBGDBDIR=fpcsrc/libgdb
ifeq ($(GDBLIBDIR),)
override GDBLIBDIR=fpcsrc/libgdb/$(OS_TARGET)
override LIBGDBDIR=fpcsrc/libgdb
endif
# Detect if libgdb.a is available
override LIBGDBFILE:=$(firstword $(wildcard $(addsuffix /libgdb.a,$(GDBLIBDIR))))
endif

# No custom libgdb.a found, try using system default library if available
ifeq ($(LIBGDBFILE),)
SYSLIBDIR=/lib /usr/lib /usr/local/lib
# Detect if libgdb.a is available
override LIBGDBFILE=$(firstword $(wildcard $(addsuffix /libgdb.a,$(SYSLIBDIR))))
ifneq (${LIBGDBFILE},)
$(warning Using system default libgdb file located in ${LIBGDBFILE})
override GDBLIBDIR=$(dir ${LIBGDBFILE})
override LIBGDBDIR=
endif
# Give an error when no libgdb.a found
ifeq ($(LIBGDBFILE),)
$(error No libgdb.a found, supply NOGDB=1 to disable debugger support)
endif
endif
endif  #ifeq ($(LOOKFORLIBGDBDIR),1)
endif  #NOGDB


##########################################################################
# Utilities (asld*.zip, make*.zip, gdb*.zip) for go32v2 and possibly os2
##########################################################################
.PHONY: utilities zip_util copy_utilfiles

UTILS_OUTDIR=$(INSTALL_PREFIX)/bin/$(TARGETSUFFIX)
ifeq ($(OS_TARGET),go32v2)
UTILS_BINSUFFIX=go32
else
UTILS_BINSUFFIX=$(SHORTSUFFIX)
endif

copy_utilfiles:
	$(MKDIRTREE) $(UTILS_OUTDIR)
	$(COPY) $(CVSINSTALL)/bin$(UTILS_BINSUFFIX)/$(UTILNAME)$(SHORTSUFFIX)/* $(UTILS_OUTDIR)

zip_util:
	$(MAKE) fpc_zipinstall ZIPTARGET=copy_utilfiles ZIPNAME=$(UTILNAME)

utilities:
	$(MAKE) zip_util UTILNAME=asld
	$(MAKE) zip_util UTILNAME=make
	$(MAKE) zip_util UTILNAME=gdb

##########################################################################
# Win32, Go32v2, OS/2
##########################################################################

.PHONY: dist

dist:
	$(MAKE) sourcezip
	$(MAKE) demozip
	$(MAKE) zipinstall
ifneq ($(findstring $(OS_TARGET),$(LIMIT83fs)),)
	$(MAKE) shortnames
endif

##########################################################################
# Debian
##########################################################################

ifeq ($(OS_TARGET),linux)

ifndef DEBDIR
DEBDIR=${CVSINSTALL}/debian
endif

ifneq ($(wildcard ${DEBDIR}/changelog),)

.PHONY: debcopy deb

DEBPACKAGEVERSION:=$(shell head -n 1 ${DEBDIR}/changelog | awk '{ print $$2 }' | tr -d '[()]')
DEBVERSION=$(firstword $(subst -, ,${DEBPACKAGEVERSION}))
DEBBUILD=$(lastword $(subst -, ,${DEBPACKAGEVERSION}))
DEBSRC=${PACKAGE_NAME}-${DEBVERSION}
DEBSRCDIR=${BUILDDIR}/${DEBSRC}
DEBSRC_ORIG=${PACKAGE_NAME}_${PACKAGE_VERSION}.orig
BUILDDATE=$(shell /bin/date --utc +%Y%m%d)
ifdef MENTORS
DEB_BUILDPKG_OPT=-sa
else
DEB_BUILDPKG_OPT=
endif
ifdef NODOCS
	DEB_BUILDPKG_OPT+= -B
endif
ifeq (${DEBBUILD},0)
DEBUSESVN=1
endif
ifeq (${DEBBUILD},1)
DEBUSESVN=1
endif
ifdef SNAPSHOT
DEBUSESVN=1
endif
ifndef SIGN
DEB_BUILDPKG_OPT+= -us -uc
endif

debcheck:
ifneq (${DEBVERSION},${PACKAGE_VERSION})
ifneq (${SNAPSHOT},1)
	! ${ECHO} "Debian version ($(DEBVERSION)) is not correct, expect $(PACKAGE_VERSION)"
endif
endif
ifeq ($(wildcard ${DEBSRC_ORIG}.tar.gz),)
ifndef DEBUSESVN
	! ${ECHO} 'Need "${DEBSRC_ORIG}.tar.gz" to build for DEBBUILD = "${DEBBUILD}" > 1'
endif
endif

debcopy: distclean
	${DELTREE} ${BUILDDIR}
	${MKDIRTREE} $(DEBSRCDIR)/fpcsrc
ifdef DEBUSESVN
	$(LINKTREE) fpcsrc/Makefile* $(DEBSRCDIR)/fpcsrc
	$(LINKTREE) fpcsrc/compiler $(DEBSRCDIR)/fpcsrc
	$(LINKTREE) fpcsrc/rtl $(DEBSRCDIR)/fpcsrc
	$(LINKTREE) fpcsrc/installer $(DEBSRCDIR)/fpcsrc
	$(LINKTREE) fpcsrc/packages $(DEBSRCDIR)/fpcsrc
	$(LINKTREE) fpcsrc/tests $(DEBSRCDIR)/fpcsrc
	$(LINKTREE) fpcsrc/utils $(DEBSRCDIR)/fpcsrc
	$(LINKTREE) demo $(DEBSRCDIR)
ifneq (${LIBGDBDIR},)
	$(LINKTREE) $(LIBGDBDIR) $(DEBSRCDIR)/fpcsrc
endif
	$(LINKTREE) fpcdocs $(DEBSRCDIR)
	${MKDIR} $(DEBSRCDIR)/install
	$(LINKTREE) install/man $(DEBSRCDIR)/install
	$(LINKTREE) install/doc $(DEBSRCDIR)/install
else
	tar -C ${BUILDDIR} -zxf ${DEBSRC_ORIG}.tar.gz ${DEBSRC}
	${DELTREE} $(DEBSRCDIR)/debian
endif

debsetup:
	$(COPYTREE) ${DEBDIR} $(DEBSRCDIR)/debian
ifeq (${SNAPSHOT},1)
ifneq (${DEBVERSION},${PACKAGE_VERSION})
	sed -i ${DEBSRCDIR}/debian/changelog \
	-e "1ifpc (${PACKAGE_VERSION}-0~${BUILDDATE}) unstable; urgency=low" \
	-e "1i\ " \
	-e "1i  * Build daily snapshots." \
	-e "1i\ " \
	-e "1i -- Abou Al Montacir <abou.almontacir@sfr.fr>  $(shell date -R)" \
	-e "1i\ "
else
	sed -e 's/${DEBPACKAGEVERSION}/${DEBPACKAGEVERSION}~${BUILDDATE}/' -i $(DEBSRCDIR)/debian/changelog
endif
endif
	chmod 755 $(DEBSRCDIR)/debian/rules
	find $(DEBSRCDIR) -name '.svn' | xargs ${DELTREE}

debbuild:
	cd ${DEBSRCDIR} ; dpkg-buildpackage ${DEB_BUILDPKG_OPT}

debcheckpolicy:
ifdef LINTIAN
	cd ${DEBSRCDIR} ; lintian -I -i ../*.changes
endif

debclean:
ifndef DEBUSESVN
	${DEL} ${BUILDDIR}/${DEBSRC_ORIG}.tar.gz
endif
	mv -v -t . \
	$(DEBSRCDIR)/../*.changes \
	$(DEBSRCDIR)/../*.deb \
	$(DEBSRCDIR)/../*.dsc \
	$(DEBSRCDIR)/../*.gz
	${DELTREE} $(DEBSRCDIR)
	rmdir $(BUILDDIR)

deb: debcheck debcopy deborigtargz debsetup debbuild debcheckpolicy debclean

deborigtargz:
ifdef DEBUSESVN
	#$(MAKE) fpc_zipinstall USETAR=y ZIPTARGET=debcopy PACKDIR=$(DEBSRCDIR) FULLZIPNAME=${DEBSRC_ORIG}
	tar -C ${BUILDDIR} -zcf ${BUILDDIR}/${DEBSRC_ORIG}.tar.gz --exclude-vcs ${DEBSRC}
else
	${LINKTREE} ${DEBSRC_ORIG}.tar.gz ${BUILDDIR}/${DEBSRC_ORIG}.tar.gz
endif

endif   # changelog found

endif


##########################################################################
# RPM
##########################################################################

ifdef inUnix

# rpm available?
RPM:=$(strip $(wildcard $(addsuffix /rpm$(SRCEXEEXT),$(SEARCHPATH))))
ifneq ($(RPM),)

ifneq ($(wildcard $(CVSINSTALL)/fpc.spec),)

.PHONY: rpmcopy rpm

# Grab the version-suffix. Used to construct the filename of the source-archive
VERSION_SUFFIX:=$(shell echo $(PACKAGE_VERSION) | awk -F '.' '{ print substr($$3,2) }')
# Extract the patch version from the suffix. The suffix _may_ contain a leading '-', like
# -beta or -rc1. That has to be removed. 
MINOR_PATCH_VERSION:=$(shell echo $(VERSION_SUFFIX) | awk {'sub("^[-]", ""); print'})
MAIN_VERSION:=$(shell echo $(PACKAGE_VERSION) | awk {'sub("[A-Z,a-z,-].*", ""); print'})
ifeq ($(MINOR_PATCH_VERSION),)
RELEASE=1
else
RELEASE=0.$(MINOR_PATCH_VERSION)
endif
# Only the recent rpms have rpmbuild
RPMBUILD=$(firstword $(strip $(wildcard $(addsuffix /rpmbuild,$(SEARCHPATH)))))
ifeq ($(RPMBUILD),)
RPMBUILD=$(firstword $(strip $(wildcard $(addsuffix /rpm,$(SEARCHPATH)))))
endif
RPMDIR=$(BUILDDIR)/rpm
RPMSPECFILE:=$(RPMDIR)/SPECS/fpc-$(PACKAGE_VERSION).spec
RPMSOURCEFILE:=$(RPMDIR)/SOURCES/fpc-$(PACKAGE_VERSION)-src.tar.gz
RPMSRCDIR:=$(RPMDIR)/SOURCES/fpc
RPMDEFINES=--define "_topdir $(RPMDIR)" \
	   --define "_sourcedir $(RPMDIR)/SOURCES" \
	   --define "_builddir $(RPMDIR)/BUILD" \
	   --define "_rpmdir $(RPMDIR)/RPMS" \
	   --define "_srcrpmdir $(RPMDIR)/SRPMS"
rpmcopy: distclean
	# false || is needed to workaround fpcmake sections
	false || [ -d $(RPMDIR) ] || install -d $(RPMDIR)
	false || [ -d $(RPMDIR)/BUILD ] || install -d $(RPMDIR)/BUILD
	false || [ -d $(RPMDIR)/SOURCES ] || install -d $(RPMDIR)/SOURCES
	false || [ -d $(RPMDIR)/SPECS ] || install -d $(RPMDIR)/SPECS
	false || [ -d $(RPMDIR)/RPMS ] || install -d $(RPMDIR)/RPMS
	false || [ -d $(RPMDIR)/SRPMS ] || install -d $(RPMDIR)/SRPMS
	rm -rf $(RPMSRCDIR)
	sed -e "s+%FPCVERSION%+$(MAIN_VERSION)+" -e "s+%VERSION_SUFFIX%+$(VERSION_SUFFIX)+" -e "s+%RELEASE%+$(RELEASE)+" $(CVSINSTALL)/fpc.spec > $(RPMSPECFILE)
ifndef NODOCS
	cat $(CVSINSTALL)/fpcdoc.spec >> $(RPMSPECFILE)
endif
	# Install files
	install -d $(RPMSRCDIR)
	$(LINKTREE) fpcsrc/compiler $(RPMSRCDIR)
	$(LINKTREE) fpcsrc/rtl $(RPMSRCDIR)
	$(LINKTREE) fpcsrc/packages $(RPMSRCDIR)
	$(LINKTREE) fpcsrc/utils $(RPMSRCDIR)
ifneq (${LIBGDBDIR},)
	$(LINKTREE) $(LIBGDBDIR) $(RPMSRCDIR)
endif
	$(LINKTREE) demo $(RPMSRCDIR)
#	$(LINKTREE) logs $(RPMSRCDIR)
	$(LINKTREE) fpcsrc/Makefile* $(RPMSRCDIR)
	$(LINKTREE) $(CVSINSTALL)/man $(RPMSRCDIR)
	$(LINKTREE) $(CVSINSTALL)/doc $(RPMSRCDIR)
	$(COPY) $(CVSINSTALL)/smart_strip.sh $(RPMSRCDIR)
	chmod +x $(RPMSRCDIR)/smart_strip.sh
ifndef NODOCS
	$(LINKTREE) fpcdocs $(RPMSRCDIR)
endif
	find $(RPMSRCDIR) -name 'CVS*' | xargs -n1 rm -rf
	find $(RPMSRCDIR) -name '.svn' | xargs -n1 rm -rf
	cd $(RPMSRCDIR) ; tar cfvz $(RPMSOURCEFILE) *
	rm -rf $(RPMSRCDIR)

rpmbuild: checkfpcdir
	$(RPMBUILD) $(RPMDEFINES) --nodeps -ba $(RPMSPECFILE)
	mv `find $(RPMDIR)/RPMS/ -name '*.rpm'` .
	mv `find $(RPMDIR)/SRPMS/ -name '*.rpm'` .

rpmclean:
	rm -rf $(RPMDIR)
	-rmdir $(BUILDDIR)

rpm: checkfpcdir rpmcopy rpmbuild rpmclean

endif   # spec found

endif   # rpm available

endif   # inUnix

##########################################################################
# Android NDK
##########################################################################

ifeq ($(OS_TARGET),android)
ifneq ($(CPU_TARGET),jvm)
ifdef CROSSCOMPILE

ifeq ($(NDK),)
  $(error It is needed to set the Android NDK path using NDK=<path>)
endif

override NDK:=$(subst $(PATHSEP),/,$(NDK))

ifeq ($(wildcard $(NDK)),)
  $(error NDK path does not exist: $(NDK))
endif

NDK_LIB:=$(NDK)/platforms/android-21
ifeq ($(wildcard $(NDK_LIB)/arch-arm64/usr/lib/crtbegin_so.o),)
  $(error Unable to find NDK library files in $(NDK_LIB))
endif

NDKARCH:=$(notdir $(firstword $(wildcard $(NDK)/prebuilt/$(OS_SOURCE)-$(CPU_SOURCE))))

ifeq ($(NDKARCH),)
  NDKARCH:=windows
endif

gettoolchain=$(dir $(firstword $(foreach d, $(wildcard $(NDK)/toolchains/$(1)-*.*), $(wildcard $(d)/prebuilt/$(NDKARCH)/bin/$(2)-ld.bfd$(SRCEXEEXT)))))

ANDROID_AARCH64_BINUTILS:=$(call gettoolchain,aarch64,aarch64-linux-android)
ifeq ($(ANDROID_AARCH64_BINUTILS),)
  WINARCH:=$(PROCESSOR_ARCHITEW6432)
  ifeq ($(WINARCH),)
    WINARCH:=$(PROCESSOR_ARCHITECTURE)
  endif
  ifeq ($(WINARCH),AMD64)
    NDKARCH:=windows-x86_64
    ANDROID_AARCH64_BINUTILS:=$(call gettoolchain,aarch64,aarch64-linux-android)
  endif
  ifeq ($(ANDROID_AARCH64_BINUTILS),)
    ANDROID_AARCH64_BINUTILS:=$(call gettoolchain,arm64,arm64-linux-android)
    ifeq ($(ANDROID_AARCH64_BINUTILS),)
      ANDROID_AARCH64_BINUTILS:=$(dir $(firstword $(wildcard $(addsuffix /aarch64-linux-android-as$(SRCEXEEXT),$(SEARCHPATH)))))
    endif
  endif
endif

ANDROID_ARM_BINUTILS:=$(call gettoolchain,arm-linux-androideabi,arm-linux-androideabi)
ifeq ($(ANDROID_ARM_BINUTILS),)
  ifeq ($(ANDROID_ARM_BINUTILS),)
    ANDROID_ARM_BINUTILS:=$(dir $(firstword $(wildcard $(addsuffix /arm-linux-androideabi-as$(SRCEXEEXT),$(SEARCHPATH)))))
    ifneq ($(ANDROID_ARM_BINUTILS),)
      $(info "ANDROID_ARM_BINUTILS is $(ANDROID_ARM_BINUTILS)")
    endif
  endif
endif

ANDROID_X86_BINUTILS:=$(call gettoolchain,x86,i686-linux-android)
ifeq ($(ANDROID_X86_BINUTILS),)
  ANDROID_X86_BINUTILS:=$(dir $(firstword $(wildcard $(addsuffix /i686-linux-android-as$(SRCEXEEXT),$(SEARCHPATH)))))
endif

ANDROID_X86_64_BINUTILS:=$(call gettoolchain,x86_64,x86_64-linux-android)
ifeq ($(ANDROID_X86_64_BINUTILS),)
  ANDROID_X86_64_BINUTILS:=$(dir $(firstword $(wildcard $(addsuffix /x86_64-linux-android-as$(SRCEXEEXT),$(SEARCHPATH)))))
endif

ANDROID_MIPS_BINUTILS:=$(call gettoolchain,mipsel-linux-android,mipsel-linux-android)
ifeq ($(ANDROID_MIPS_BINUTILS),)
  ANDROID_MIPS_BINUTILS:=$(dir $(firstword $(wildcard $(addsuffix /mipsel-linux-android-as$(SRCEXEEXT),$(SEARCHPATH)))))
endif

unexport BUILDFULLNATIVE

ifeq ($(CPU_TARGET),arm)
  ifeq ($(ANDROID_ARM_BINUTILS),)
    $(error Unable to find binutils for arm-android)
  endif
  CROSSBINDIR=$(ANDROID_ARM_BINUTILS)
  override LIBDIR+=$(NDK_LIB)/arch-arm/usr/lib
endif

ifeq ($(CPU_TARGET),aarch64)
  ifeq ($(ANDROID_AARCH64_BINUTILS),)
    $(error Unable to find binutils for aarch64-android)
  endif
  CROSSBINDIR=$(ANDROID_AARCH64_BINUTILS)
  override LIBDIR+=$(NDK_LIB)/arch-arm64/usr/lib
endif

ifeq ($(CPU_TARGET),i386)
  ifeq ($(ANDROID_X86_BINUTILS),)
    $(error Unable to find binutils for i386-android)
  endif
  CROSSBINDIR=$(ANDROID_X86_BINUTILS)
  override LIBDIR+=$(NDK_LIB)/arch-x86/usr/lib
endif

ifeq ($(CPU_TARGET),x86_64)
  ifeq ($(ANDROID_X86_64_BINUTILS),)
    $(error Unable to find binutils for x86_64-android)
  endif
  CROSSBINDIR=$(ANDROID_X86_64_BINUTILS)
  override LIBDIR+=$(NDK_LIB)/arch-x86_64/usr/lib64
endif

ifeq ($(CPU_TARGET),mipsel)
  ifeq ($(ANDROID_MIPS_BINUTILS),)
    $(error Unable to find binutils for mipsel-android)
  endif
  CROSSBINDIR=$(ANDROID_MIPS_BINUTILS)
  override LIBDIR+=$(NDK_LIB)/arch-mips/usr/lib
endif

export CROSSBINDIR
export BINUTILSPREFIX
export LIBDIR

endif
endif
endif

##########################################################################
# Inno setup
##########################################################################

ifndef ISCCPROG
ISCCPROG=$(subst $(PATHSEP),/,$(ProgramFiles))/inno setup 5/iscc.exe
endif # ISCCPROG

ifndef inUnix
USEINNOWRAPPER=1
endif
INNODIR=$(BUILDDIR)/inno
INNOWRAPPER=$(subst /,$(PATHSEP),$(DIST_DESTDIR)/fpcinno$(SRCBATCHEXT))
INNOCMD_CDINNO:=cd $(subst /,$(ZIPPATHSEP),$(INNODIR))
INNOCMD_CDBASE:=cd $(subst /,$(ZIPPATHSEP),$(BASEDIR))
INNOCMD_ISCC:="$(ISCCPROG)" "$(subst /,$(PATHSEP),$(INNODIR)/fpc.iss)"
FPCISSSUBST=-d BUILDDIR=$(subst /,$(PATHSEP),$(INNODIR))
ifdef NODOCS
FPCISSSUBST+=-d DisableDocs=;
endif

innocheck:
ifndef NODOCS
# Check for doc-pdf.zip
ifeq ($(wildcard doc-pdf.zip),)
	@$(ECHO) "No documentation available. Please copy the file doc-pdf.zip to this directory."
	@exit 1
endif
endif
ifeq ($(LOOKFORLIBGDBDIR),1)
# Check for libgdb
ifeq ($(wildcard fpcsrc/libgdb/win32/libgdb.a),)
ifeq ($(wildcard fpcsrc/libgdb/win32/i386/libgdb.a),)
	@$(ECHO) "Libgdb not available. Please get and unzip libgdb-*.i386-win32.zip in fpcsrc/."
	@exit 1
endif
endif
endif

innobuild: innocheck build
	rmcvsdir$(EXEEXT) $(INNODIR)
	$(DELTREE) $(INNODIR)
	$(MKDIR) $(INNODIR)
	$(COPYTREE) demo $(INNODIR)
	$(COPYTREE) install/unicode $(INNODIR)
ifndef NODOCS
	unzip -d $(INNODIR) doc-pdf.zip
endif
	$(MAKE) install INSTALL_PREFIX=$(INNODIR)
	rmcvsdir$(EXEEXT) $(INNODIR)
	fpcmkcfg -t install/fpc.ist -o $(INNODIR)/fpc.iss $(FPCISSSUBST) -d FPCVERSION=$(PACKAGE_VERSION)
	$(INNOCMD_ISCC)
	$(MOVE) $(INNODIR)/Output/fpc-setup.exe fpc-$(PACKAGE_VERSION).$(FULL_TARGET).exe

innocebuild: innocheck buildce
	rmcvsdir$(EXEEXT) $(INNODIR)
	$(DELTREE) $(INNODIR)
	$(MKDIR) $(INNODIR)
	$(COPYTREE) demo $(INNODIR)
	$(MAKE) crossinstall INSTALL_PREFIX=$(INNODIR) OS_TARGET=wince CPU_TARGET=arm
	rmcvsdir$(EXEEXT) $(INNODIR)
	fpcmkcfg -t install/fpcce.ist -o $(INNODIR)/fpcce.iss $(FPCISSSUBST) -d FPCVERSION=$(PACKAGE_VERSION)
	"$(ISCCPROG)" $(INNODIR)/fpcce.iss
	$(MOVE) $(INNODIR)/Output/fpc-setup.exe fpc-$(PACKAGE_VERSION).$(FULL_SOURCE).cross.$(FULL_TARGET).exe

innox64build: innocheck buildx64
	rmcvsdir$(EXEEXT) $(INNODIR)
	$(DELTREE) $(INNODIR)
	$(MKDIR) $(INNODIR)
	$(COPYTREE) demo $(INNODIR)
	$(MAKE) crossinstall INSTALL_PREFIX=$(INNODIR) OS_TARGET=win64 CPU_TARGET=x86_64
	rmcvsdir$(EXEEXT) $(INNODIR)
	fpcmkcfg -t install/fpcx64.ist -o $(INNODIR)/fpcx64.iss $(FPCISSSUBST) -d FPCVERSION=$(PACKAGE_VERSION)
	"$(ISCCPROG)" $(INNODIR)/fpcx64.iss
	$(MOVE) $(INNODIR)/Output/fpc-setup.exe fpc-$(PACKAGE_VERSION).$(FULL_SOURCE).cross.$(FULL_TARGET).exe

innox86x64build: innocheck
	rmcvsdir$(EXEEXT) $(INNODIR)
	$(DELTREE) $(INNODIR)
	$(MKDIR) $(INNODIR)
	$(COPYTREE) demo $(INNODIR)
	$(COPYTREE) install/unicode $(INNODIR)
ifndef NODOCS
	unzip -d $(INNODIR) doc-pdf.zip
endif
	$(MAKE) install INSTALL_PREFIX=$(INNODIR)
	$(MAKE) crossinstall INSTALL_PREFIX=$(INNODIR) OS_TARGET=win64 CPU_TARGET=x86_64
	rmcvsdir$(EXEEXT) $(INNODIR)
	fpcmkcfg -t install/fpcx86x64.ist -o $(INNODIR)/fpc.iss $(FPCISSSUBST) -d FPCVERSION=$(PACKAGE_VERSION)
	$(INNOCMD_ISCC)
	$(MOVE) $(INNODIR)/Output/fpc-setup.exe fpc-$(PACKAGE_VERSION).win32.and.win64.exe

innojvmbuild: innocheck buildjvm
	rmcvsdir$(EXEEXT) $(INNODIR)
	$(DELTREE) $(INNODIR)
	$(MKDIR) $(INNODIR)
# currently, jvm supports only buildbase, so we have to use installbase here		
	$(MAKE) installbase INSTALL_PREFIX=$(INNODIR) OS_TARGET=java CPU_TARGET=jvm
	$(MAKE) installbase INSTALL_PREFIX=$(INNODIR) OS_TARGET=android CPU_TARGET=jvm
	rmcvsdir$(EXEEXT) $(INNODIR)
	fpcmkcfg -t install/fpcjvm.ist -o $(INNODIR)/fpcjvm.iss $(FPCISSSUBST) -d FPCVERSION=$(PACKAGE_VERSION)
	"$(ISCCPROG)" $(INNODIR)/fpcjvm.iss
	$(MOVE) $(INNODIR)/Output/fpc-setup.exe fpc-$(PACKAGE_VERSION).$(FULL_SOURCE).cross.$(CPU_TARGET).exe

buildmsdos_subarch_mm: fpcsrc/build-stamp.cross-msdos
	$(MAKE) -C fpcsrc/rtl clean FPC=$(realpath ./fpcsrc/compiler/ppcross8086.exe) OS_TARGET=msdos CPU_TARGET=i8086 OPT="-CX -XXs" BINUTILSPREFIX= CROSSOPT="$(OPT) -CX -XXs -Wm$(MEMORY_MODEL) -Cp$(SUBARCH)"
	$(MAKE) -C fpcsrc/rtl install FPC=$(realpath ./fpcsrc/compiler/ppcross8086.exe) OS_TARGET=msdos CPU_TARGET=i8086 OPT="-CX -XXs" BINUTILSPREFIX= CROSSOPT="$(OPT) -CX -XXs -Wm$(MEMORY_MODEL) -Cp$(SUBARCH)"
	$(MAKE) -C fpcsrc/packages clean FPC=$(realpath ./fpcsrc/compiler/ppcross8086.exe) OS_TARGET=msdos CPU_TARGET=i8086 OPT="-CX -XXs" BINUTILSPREFIX= CROSSOPT="$(OPT) -CX -XXs -Wm$(MEMORY_MODEL) -Cp$(SUBARCH)" FPCFPMAKE=$(BASEDIR)/fpcsrc/compiler/ppc
	$(MAKE) -C fpcsrc/packages install FPC=$(realpath ./fpcsrc/compiler/ppcross8086.exe) OS_TARGET=msdos CPU_TARGET=i8086 OPT="-CX -XXs" BINUTILSPREFIX= CROSSOPT="$(OPT) -CX -XXs -Wm$(MEMORY_MODEL) -Cp$(SUBARCH)" FPCFPMAKE=$(BASEDIR)/fpcsrc/compiler/ppc
	$(MOVE) $(INSTALL_BASEDIR)/units/msdos $(INSTALL_BASEDIR)/units/msdos_/$(SUBARCH)-$(MEMORY_MODEL)

buildmsdos_subarch:
	$(MAKE) buildmsdos_subarch_mm MEMORY_MODEL=tiny
	$(MAKE) buildmsdos_subarch_mm MEMORY_MODEL=small
	$(MAKE) buildmsdos_subarch_mm MEMORY_MODEL=medium
	$(MAKE) buildmsdos_subarch_mm MEMORY_MODEL=compact
	$(MAKE) buildmsdos_subarch_mm MEMORY_MODEL=large
	$(MAKE) buildmsdos_subarch_mm MEMORY_MODEL=huge

innomsdosbuild: innocheck
	rmcvsdir$(EXEEXT) $(INNODIR)
	$(DELTREE) $(INNODIR)
	$(MKDIR) $(INNODIR)
	$(COPYTREE) demo $(INNODIR)
	$(MKDIR) $(INNODIR)/doc
	$(MKDIR) $(INNODIR)/doc/fpc
	$(COPY) -R install/doc/* $(INNODIR)/doc/fpc
	$(MKDIR) $(INNODIR)/units/msdos_
	$(MAKE) -C fpcsrc/ compiler_cycle RELEASE=1 OS_SOURCE=win32 CPU_SOURCE=i386 CPU_TARGET=i8086 OS_TARGET=msdos OPT="-CX -XXs" BINUTILSPREFIX= CROSSOPT="$(OPT) -CX -XXs"
	$(MAKE) -C fpcsrc/ compiler_install RELEASE=1 OS_SOURCE=win32 CPU_SOURCE=i386 CPU_TARGET=i8086 OS_TARGET=msdos OPT="-CX -XXs" BINUTILSPREFIX= CROSSOPT="$(OPT) -CX -XXs" INSTALL_PREFIX=$(INNODIR)
	$(MAKE) buildmsdos_subarch SUBARCH=8086 OS_SOURCE=win32 CPU_SOURCE=i386 INSTALL_PREFIX=$(INNODIR)
	$(MAKE) buildmsdos_subarch SUBARCH=80186 OS_SOURCE=win32 CPU_SOURCE=i386 INSTALL_PREFIX=$(INNODIR)
	$(MAKE) buildmsdos_subarch SUBARCH=80286 OS_SOURCE=win32 CPU_SOURCE=i386 INSTALL_PREFIX=$(INNODIR)
	$(MAKE) buildmsdos_subarch SUBARCH=80386 OS_SOURCE=win32 CPU_SOURCE=i386 INSTALL_PREFIX=$(INNODIR)
	$(MOVE) $(INNODIR)/units/msdos_ $(INNODIR)/units/msdos
	$(COPY) install/crossbinmsdos/nasm.exe $(INNODIR)/bin/i386-win32
	rmcvsdir$(EXEEXT) $(INNODIR)
	fpcsubst -i install/fpcmsdos.ist -o $(INNODIR)/fpcmsdos.iss $(FPCISSSUBST) -d FPCVERSION=$(PACKAGE_VERSION)
	"$(ISCCPROG)" $(INNODIR)/fpcmsdos.iss
	$(MOVE) $(INNODIR)/Output/fpc-setup.exe fpc-$(PACKAGE_VERSION).$(FULL_SOURCE).cross.$(FULL_TARGET).exe

innoandroidbuild:
	rmcvsdir$(EXEEXT) $(INNODIR)
	$(DELTREE) $(INNODIR)
	$(MKDIR) $(INNODIR)
# arm
	$(MAKE) -C fpcsrc rtl_clean packages_clean OS_TARGET=android CPU_TARGET=arm
	$(MAKE) build OS_TARGET=android CPU_TARGET=arm CROSSINSTALL=1
	$(MAKE) crossinstall INSTALL_PREFIX=$(INNODIR) OS_TARGET=android CPU_TARGET=arm
	$(MOVE) $(INNODIR)/units/arm-android $(INNODIR)/units/armv5t-android
	$(MOVE) $(INNODIR)/fpmkinst/arm-android $(INNODIR)/fpmkinst/armv5t-android
	$(DEL) fpcsrc/build-stamp.arm-android
# arm-v7a
	$(MAKE) -C fpcsrc rtl_clean packages_clean OS_TARGET=android CPU_TARGET=arm
	$(MAKE) build OS_TARGET=android CPU_TARGET=arm CROSSOPT="-Cparmv7a -Cfvfpv3_d16" CROSSINSTALL=1
	$(MAKE) crossinstall INSTALL_PREFIX=$(INNODIR) OS_TARGET=android CPU_TARGET=arm
	$(MOVE) $(INNODIR)/units/arm-android $(INNODIR)/units/armv7a-android
	$(MOVE) $(INNODIR)/fpmkinst/arm-android $(INNODIR)/fpmkinst/armv7a-android
	$(DEL) fpcsrc/build-stamp.arm-android
# aarch64
	$(MAKE) build OS_TARGET=android CPU_TARGET=aarch64 CROSSINSTALL=1
	$(MAKE) crossinstall INSTALL_PREFIX=$(INNODIR) OS_TARGET=android CPU_TARGET=aarch64
# i386
	$(MAKE) build OS_TARGET=android CPU_TARGET=i386 CROSSINSTALL=1
	$(MAKE) crossinstall INSTALL_PREFIX=$(INNODIR) OS_TARGET=android CPU_TARGET=i386
# x86_64
	$(MAKE) build OS_TARGET=android CPU_TARGET=x86_64 CROSSINSTALL=1
	$(MAKE) crossinstall INSTALL_PREFIX=$(INNODIR) OS_TARGET=android CPU_TARGET=x86_64
# mipsel
	$(MAKE) build OS_TARGET=android CPU_TARGET=mipsel CROSSINSTALL=1
	$(MAKE) crossinstall INSTALL_PREFIX=$(INNODIR) OS_TARGET=android CPU_TARGET=mipsel
	rmcvsdir$(EXEEXT) $(INNODIR)
	fpcmkcfg -t install/fpcandroid.ist -o $(INNODIR)/fpcandroid.iss $(FPCISSSUBST) -d FPCVERSION=$(PACKAGE_VERSION)
	"$(ISCCPROG)" $(INNODIR)/fpcandroid.iss
	$(MOVE) $(INNODIR)/Output/fpc-setup.exe fpc-$(PACKAGE_VERSION).$(FULL_SOURCE).cross.android.exe

innoclean:
	rmcvsdir$(EXEEXT) $(INNODIR)
	$(DELTREE) $(INNODIR)

innoce : checkfpcdir
	$(MAKE) OS_TARGET=wince CPU_TARGET=arm innocebuild NOGDB=1
	$(MAKE) innoclean	

innox64 : checkfpcdir
	$(MAKE) OS_TARGET=win64 CPU_TARGET=x86_64 innox64build NOGDB=1
	$(MAKE) innoclean	

innox86x64 : checkfpcdir
	$(MAKE) innox86x64build
	$(MAKE) innoclean

innojvm : checkfpcdir
	$(MAKE) OS_TARGET=java CPU_TARGET=jvm innojvmbuild NOGDB=1
	$(MAKE) innoclean	

innomsdos : checkfpcdir
	$(MAKE) OS_TARGET=msdos CPU_TARGET=i8086 innomsdosbuild NOGDB=1 CROSSBINDIR=$(BASEDIR)/install/crossbinmsdos
	$(MAKE) innoclean	

innoandroid : checkfpcdir
	$(MAKE) innoandroidbuild NOGDB=1
	$(MAKE) innoclean

inno: checkfpcdir innobuild innoclean
